class Class {
  String name, location, timeStarts, timeEnds;
  float timeStart, timeEnd;
  boolean[] days = {false, false, false, false, false, false, false};
  color c = color(180, 0, 0);
  
  Class(String name, String location, String days, String timeStarts, String timeEnds) {
    this(name, location, days, timeStarts, timeEnds, 230, 230, 230);
  }
  
  Class(String name, String location, String days, String timeStarts, String timeEnds, int r, int g, int b) {
    this.name = name;
    this.location = location; 
    this.timeStarts = timeStarts;
    this.timeEnds = timeEnds;
    this.c = color(r, g, b);
    this.c = color(230); //Hard reset to white, for greyscale printing. 
    timeStart = 8; timeEnd = 9; //Default times. Retained only if parseTime fails. 
    timeStart = string2time(timeStarts);
    timeEnd =   string2time(timeEnds);
    
    //Populate days array. 
    String daylookup = "";
    if (WEEK_DAYS == 7) daylookup = "SMTWRFA";
    if (WEEK_DAYS == 5) daylookup = "MTWRF";
    for (int i = 0; i < daylookup.length(); i++) {
      if (days.contains(daylookup.substring(i, i+1))) this.days[i] = true;
    }
  }
  
  void draw() {
    noStroke();
    strokeWeight(1);
    rectMode(CORNERS);
    for (int i = 0; i < WEEK_DAYS; i++) {
      //Only draw a rectangle for active days.
      if (days[i] == false) continue;
      
      //Origin: day2x(i), time2y(timeStart)
      //Width: dayWidth()
      //Height: time2y(timeEnd) - time2y(timeStart)
      fill(c);
      rect(day2x(i), time2y(timeStart), day2x(i) + dayWidth(), time2y(timeEnd));
      
      textFont(MAIN_TEXT);
      textAlign(LEFT, TOP);
      fill(0);
      text(getText(), day2x(i) + PADDING, time2y(timeStart) + PADDING/2);
    }
  }
  
  //Assemble info text for a calendar entry, omitting any empty fields. 
  String getText() {
    String t = "";
    if (!name.equals("")) t += name + "\n";
    if (!location.equals("")) t += location + "\n";
    if (!timeStarts.equals("")) t += timeStarts;
    if (!timeEnds.equals("")) t += " - " + timeEnds;
    return t;
  }
  
  String getName()                  {return this.name;}
  String getLocation()              {return this.location;}
  String gettimeStart()             {return this.timeStarts;} //Preserve user's time formatting by storing input text separate from the internal Class time.
  String gettimeEnd()               {return this.timeEnds;} //Preserve user's time formatting by storing input text separate from the internal Class time.  
  color getColor()                  {return this.c;}
  
  void setName(String name)          {this.name = name;}
  void setLocation(String location)  {this.location = location;}
  void settimeStart(String timeStart){this.timeStarts = timeStart; this.timeStart = string2time(timeStart);}
  void settimeEnd(String timeEnd)    {this.timeEnds = timeEnd; this.timeEnd = string2time(timeEnd);}
  void setColor(color c)             {this.c = c;}
}
